import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.imageio.*;

public class JClearDialog extends JDialog {
	
I18N messages = I18N.getInstance();

final static Color GRUEN     = new Color(32,84,74);
final static Color GRAU      = new Color(60,60,60);
final static Color HELLGRAU  = new Color(200,200,200);
final static Color ROT       = new Color(150,15,15);
final static Color LCD       = new Color(178,208,184);

public class JClearPanel extends JPanel 
	implements ActionListener, MouseListener, MouseMotionListener {

    //---------------------------------------------------------------
	
	JLabel MoveTitle;
	int mouseX, mouseY, dx, dy;

     //---------------------------------------------------------------

     private class JKeyButton extends Button {

		final Dimension bSize = new Dimension(140, 80);
		public JKeyButton(String name, int fSize, Color bgColor) {
			super(name);
			setForeground(HELLGRAU);
			setBackground(bgColor);
            setFont(new Font("SansSerif", Font.PLAIN, fSize ));
			setPreferredSize(bSize);
			setMaximumSize(bSize);
			setMinimumSize(bSize);
		}
	 
	 }

    //---------------------------------------------------------------

    JKeyButton allButton, windowButton, cancelButton;
    
    //---------------------------------------------------------------

     protected JKeyButton makebutton( String name, Color Farbe) {
         JKeyButton button = new JKeyButton(name, 25, Farbe);
		 button.addActionListener(this);
         return button;
     }

     public JClearPanel() {
         GridBagLayout gridbag = new GridBagLayout();
         GridBagConstraints c = new GridBagConstraints();
		 
		 c.anchor = GridBagConstraints.CENTER;
		 
         setLayout(gridbag);
		 
         c.fill = GridBagConstraints.BOTH;
         c.gridheight=1;
         c.weightx = 1.0;
         c.weighty = 0.0;
         c.insets = new Insets(10,10,10,10);

		 setBackground(HELLGRAU);

		Image icon = null;

  		 try {
		 	icon = ImageIO.read(getClass().getResource("/pics/question.png"));
		 } catch(IOException e) { e.printStackTrace();	}

  		 MoveTitle = new JLabel("?", JLabel.CENTER);
         MoveTitle.setFont(new Font("SansSerif", Font.BOLD, 30 ));
		 MoveTitle.setIcon(new ImageIcon(icon));
		 MoveTitle.setIconTextGap(20);
         MoveTitle.setForeground(Color.BLACK);
         MoveTitle.addMouseListener(this); 
         MoveTitle.addMouseMotionListener(this);

		 c.gridx = 0; c.gridy = 0; c.gridwidth=3;
         gridbag.setConstraints(MoveTitle, c);
         add(MoveTitle);

         c.weightx = 1.0;
         c.weighty = 0.0;
		 c.fill = GridBagConstraints.BOTH;
		 c.anchor = GridBagConstraints.CENTER;
         c.insets = new Insets(20,20,20,20);
		 
		 c.gridx = 0; c.gridy = 1; c.gridwidth=1;

         windowButton = makebutton(messages.getStr("clear.window"), GRUEN);
         gridbag.setConstraints(windowButton, c);
         add(windowButton);

		 c.gridx = 1;	c.gridy = 1;
         allButton = makebutton(messages.getStr("clear.all"), GRUEN);
         gridbag.setConstraints(allButton, c);
         add(allButton);

		 c.gridx = 2;	c.gridy = 1;
         cancelButton  = makebutton(messages.getStr("clear.cancel"), ROT);
         gridbag.setConstraints(cancelButton, c);
         add(cancelButton);
     }

     public void actionPerformed (ActionEvent ae){
        if ( ae.getSource() instanceof JKeyButton ) {
			JKeyButton actButton = (JKeyButton)ae.getSource();
            JClearDialog dialog = (JClearDialog)SwingUtilities.getRoot(this);
			
			if ( actButton == cancelButton ) { dialog.exit("cancel"); }
			if ( actButton == windowButton ) { dialog.exit("window"); }
			if ( actButton == allButton )    { dialog.exit("all");	  }

		} // if Button
		
     } // end of actionPerformed


	public void mouseMoved(MouseEvent e) {}

	public void mouseDragged(MouseEvent e) {
	dx = e.getX()-mouseX;
	dy = e.getY()-mouseY;

    JClearDialog dialog = (JClearDialog)SwingUtilities.getRoot(this);
	Point pos = dialog.getLocation();
	dialog.setLocation((int)pos.getX()+dx, (int)pos.getY()+dy);

	}

	public void mouseClicked (MouseEvent mouseEvent) {} 
    public void mouseEntered (MouseEvent mouseEvent) {} 
    
    public void mousePressed (MouseEvent e) {
		mouseX = e.getX(); mouseY = e.getY();
	} 
	  	
		
    public void mouseReleased (MouseEvent mouseEvent) {}  
    public void mouseExited (MouseEvent mouseEvent) {}  
    
		
 } // end of JKeyPanel

// //////////////////////////////////////////////////////////////////

    private JClearPanel yesnopanel = new JClearPanel();
    
    private String result;
    
	public void start() {
		this.yesnopanel.MoveTitle.setText(messages.getStr("clear.question"));
        setVisible(true);
	}

	public String returnValue() {
		return result;
	}

	private void exit(String info) {
		result=info;
        setVisible(false);
	}

	public JClearDialog() {
 
      add("Center", yesnopanel);

      setResizable(false);
      setUndecorated(true);

      getContentPane().setPreferredSize(new Dimension(600, 200));
      pack();
      setLocationRelativeTo(null);
      setModal(true);
      setVisible(false);

	}

}
