import java.io.*;
import java.awt.*;	
import java.awt.event.*;
import java.awt.image.*;
import java.awt.BorderLayout;
import javax.swing.*;
import javax.swing.border.*;
import javax.imageio.*;
import java.util.*;

public class JWB_Tafel
  extends JFrame implements KeyListener {

	Point 			frameLocation;
	Dimension		frameSize;
	
	JMenuPanel		MenuPanel;
	JBoardPanel		BoardPanel;
	JClearDialog	clearDialog;
	
	JInfoDialog     infoDialog;

	//----------------------------------------------------------

	public void switchFullscreen () {
	
	if ( getExtendedState() == Frame.MAXIMIZED_BOTH ) {
		setExtendedState(Frame.NORMAL); 
	} else {
		setExtendedState(Frame.MAXIMIZED_BOTH);
	}

	repaint();
	
	}

	//----------------------------------------------------------

	public JWB_Tafel () {
		super("JWB Tafel");

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		GraphicsConfiguration gc = getGraphicsConfiguration();
		Rectangle bounds = gc.getBounds();
		Insets screenInsets = Toolkit.getDefaultToolkit().getScreenInsets(gc);

		int screenWidth  = bounds.width - screenInsets.left - screenInsets.right - 200;
		int screenHeight = bounds.height - screenInsets.top - screenInsets.bottom - 200;
		
		getContentPane().setPreferredSize(new Dimension(screenWidth, screenHeight));

		MenuPanel = new JMenuPanel(this);
		BoardPanel = new JBoardPanel(this);
		
		BoardPanel.setPenColor(MenuPanel.black.getColor());
		BoardPanel.setPenCursor(MenuPanel.black.getCursor());

		clearDialog = new JClearDialog();

		infoDialog = new JInfoDialog(this);

		try {
			Image icon = ImageIO.read(getClass().getResource("/pics/blackboard_128.png"));
			setIconImage(icon);
		} catch(IOException e) { e.printStackTrace();	}

		getContentPane().add(BoardPanel, BorderLayout.CENTER);
		getContentPane().add(MenuPanel, BorderLayout.SOUTH);

		pack();	setLocationRelativeTo(null); setVisible(true);  
		requestFocus();

		addKeyListener(this);

		I18N messages = I18N.getInstance();
		
	}

	public void keyPressed(KeyEvent e){ 
		if ( e.getKeyCode() == KeyEvent.VK_UP ) {
			BoardPanel.scroll(-1);
         }
		if ( e.getKeyCode() == KeyEvent.VK_DOWN ) {
			BoardPanel.scroll(1);
         }
		if ( e.getKeyCode() == KeyEvent.VK_PAGE_UP ) {
			BoardPanel.scroll(-BoardPanel.getHeight()/2 );
         }
		if ( e.getKeyCode() == KeyEvent.VK_PAGE_DOWN ) {
			BoardPanel.scroll( BoardPanel.getHeight()/2 );
         }
		if ( e.getKeyCode() == KeyEvent.VK_HOME ) {
			BoardPanel.scrollTo(0);
         }
		if ( e.getKeyCode() == KeyEvent.VK_END ) {
			BoardPanel.scrollTo( BoardPanel.maxY - BoardPanel.getHeight() );
         }
	}

    public void keyReleased(KeyEvent e) {
	}
    
    public void keyTyped(KeyEvent e) {
	}


    public void exit() {

/*		try {
			ImageIO.write(BoardPanel.image, "png",new File("bild.png"));
		} catch (IOException e) { e.printStackTrace(); }  */

		System.out.println( BoardPanel.background.getAllStyles() );

		System.exit(0);


	}
	
	//--------------------------------------------------------
    
	public static void main(String[] args){
		
		String os = System.getProperty("os.name");
		
		String ui = UIManager.getSystemLookAndFeelClassName();
		
		if ( os.startsWith("Linux") ) {
			ui = "com.sun.java.swing.plaf.gtk.GTKLookAndFeel";
		}

		if ( os.startsWith("Windows") ) {
			ui = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
		}
		
		try {
			UIManager.setLookAndFeel(ui);
		} catch (UnsupportedLookAndFeelException e) {}
		  catch (ClassNotFoundException e) {}
		  catch (InstantiationException e) {}
		  catch (IllegalAccessException e) {}
		  
		JWB_Tafel frame = new JWB_Tafel();
	}

} 
